SuperStrict

Framework brl.blitz
Import brl.eventqueue
Import maxgui.win32maxguiex
Import "tray.c"

' -------------------------------------------------------------------------------------------------
' Tray Functions
Extern
	Function __windowToTray:Byte Ptr(hwnd:Int, id:Int, tip:Byte Ptr, iconFile:Byte Ptr)
	Function __windowFromTray(hwnd:Int, id:Int, tip:Byte Ptr, iconFile:Byte Ptr)
End Extern
Type TTrayManager
	Global ids:Int[] = New Int[200]
	Global trayList:TList = New TList
    
	Field window:TGadget
	Field tip:String
	Field icon:String
	Field func(window:TGadget, MSG:Int)
	Field id:Int

	Function windowToTray(window:TGadget, tip:String = "", icon:String = "", func(window:TGadget, msg:Int) = Null)
			Local newTray:TTrayManager = New TTrayManager
		newTray.window = window
		newTray.tip = tip
		newTray.icon = icon
		newTray.func = func
		SetWindowLongW(QueryGadget(window, QUERY_HWND), GWL_WNDPROC, Int Byte Ptr ___traysystem___Callback)
			Local id:Int = 0
		For Local i:Int = 0 To 199
			If(TTrayManager.ids[i] = 0) Then
				id = i
				Exit
			EndIf
		Next
		TTrayManager.ids[id] = 1
		newTray.id = id
		If(func) Then
			newTray.func = func
		Else
			newTray.func = __traysystem__defaultfunc
		EndIf
		__windowToTray(QueryGadget(window, QUERY_HWND), id, tip.ToCString(), icon.ToCString())
		TTrayManager.trayList.AddLast(newTray)
	End Function
    
	Function windowFromTray(window:Tgadget)
		For Local tray:TTrayManager = EachIn TTrayManager.trayList
			If(tray.window = window) Then
				__windowFromTray(QueryGadget(tray.window, QUERY_HWND), tray.id, tray.tip.ToCString(), tray.icon.ToCString())
				TTrayManager.ids[tray.id] = 0
				TTrayManager.trayList.Remove(tray)
			EndIf
		Next
	End Function
End Type
Function ___traysystem___Callback:Int(hwnd:Int, msg:Int, wparam:Int, lparam:Int) "win32"
	For Local tray:TTrayManager = EachIn TTrayManager.trayList
		If(msg = 1024 + tray.id) Then
			If(lparam = 515) Then ' Linke Maustaste  DOPPELKLICK
				If(tray.func) Then tray.func(tray.window, 1)
				ElseIf(lparam = 517) Then ' Rechte Maustaste DOPPELKLICK
					If(tray.func) Then tray.func(tray.window, 2)
			EndIf
		EndIf
	Next
	Return TWindowsGUIDriver.ClassWndProc(hwnd, msg, wparam, lparam)
End Function
Function __traysystem__defaultfunc(window:TGadget, msg:Int)
	ShowGadget(window)
	TTrayManager.windowFromTray(window)
End Function
Function windowToTray(window:TGadget, tip:String = "", icon:String = "", func(window:TGadget, msg:Int) = Null)
		TTrayManager.windowToTray(window, tip, icon, func)
End Function
Function windowFromTray(window:TGadget)
	TTrayManager.windowFromTray(window)
End Function
' -------------------------------------------------------------------------------------------------

Global window:TGadget = CreateWindow("Tray Demo WND", 100, 100, 200, 100, Null, WINDOW_TITLEBAR | WINDOW_CLIENTCOORDS | WINDOW_RESIZABLE)
windowToTray(window, "Tray Demo", "icon.ico", trayFunc)

Repeat
WaitEvent()
Local evSource:Object = EventSource()
Select EventID()
	Case EVENT_APPTERMINATE
		Exit
	Case EVENT_WINDOWCLOSE
		HideGadget(window)
		Default
	'	Print "EvID: " + Hex(EventID())
	'	Print EventData()
End Select
	
Forever

End

Function trayFunc(_win:TGadget, msg:Int)
	If _win = window
		If msg = 1
			ShowGadget window
			EnableGadget window
		ElseIf msg = 2
			Local ev:TEvent = CreateEvent(EVENT_APPTERMINATE)
			PostEvent(ev)
		End If
	End If
End Function

